%define prefix /usr/%{_lib}/im
%define canna_ver 3.6

Summary:IIIMF Input Method Software Developpers Kit
Name: im-sdk
Epoch: 1
Version: 11.4
Release: 12.15AX
License: Distributable
Source: %{name}-%{version}.tar.bz2
Source1: %{name}-htt.conf
Patch0: %{name}-20040203-build.patch
#Patch1: %{name}-20011223-DESTDIR.patch
#Patch2: %{name}-20011223-strlcpy.patch
Patch3: im-sdk-20030618-varargs.patch
#Patch4: xiiimp-status_no_status_text.patch
Patch5: im-sdk-64bit.patch
Patch6: im-sdk-gimlet.patch
#Patch7: gimlet-korean-name-115423.patch
Patch21: im-sdk-11.4-composeIM.patch
Patch22: im-sdk-11.4-conversionkeys.patch
Patch23: im-sdk-11.4-statuswin.patch
Patch25: im-sdk-11.4-canna-support-bs-and-del.patch
Patch26: im-sdk-11.4-canna-user-init-file.patch
Patch28: im-sdk-11.4-canna-no-process-unrelated-keys.patch
Patch29: im-sdk-11.4-canna-ignore-ctrl.patch

URL: http://www.openi18n.org/
Group: User Interface/X
Obsoletes: im-sdk
Requires: intltool >= 0.29-1
Buildroot: %{_tmppath}/%{name}-%{version}-root
BuildPreReq: tcp_wrappers
BuildRequires: Canna-devel >= %{canna_ver}

%description
im-sdk is a IIIMF Input Method Software Developers Kit. 

%package -n iiimf-csconv
Summary:      Codeset Conversion modules for IIIMF components
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on

%description -n iiimf-csconv
Provides Codeset Conversion modules for IIIMF components.

%package -n iiimf-protocol-lib
Summary:      Internet/Intranet Input Method Protocol library
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on

%description -n iiimf-protocol-lib
Provides Internet/Intranet Input Method Protocol library.

%package -n iiimf-protocol-lib-devel
Summary:      Internet/Intranet Input Method Protocol library header files.
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on

%description -n iiimf-protocol-lib-devel
Provides Internet/Intranet Input Method Protocol library header files.

%package -n iiimf-client-lib
Summary:      Internet/Intranet Input Method Client Framework library
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on
Requires:	iiimf-protocol-lib >= 11_4-4

%description -n iiimf-client-lib
Provides Internet/Intranet Input Method Client Framework library.

%package -n iiimf-client-lib-devel
Summary:      Internet/Intranet Input Method Client Framework library header files.
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on

%description -n iiimf-client-lib-devel
Provides Internet/Intranet Input Method Client Framework library header files.

%package -n iiimf-server
Summary:      IIIMF input method server
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on
Requires:	iiimf-csconv >= 11_4-4
Requires:	iiimf-protocol-lib >= 11_4-4
Requires:	iiimf-client-lib >= 11_4-4

%description -n iiimf-server
IIIMF server is a server module of Internet/Intranet Input Method Framework.

%package -n iiimf-le-unit
Summary:      Unit language engine for iiimf-server
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on
Requires:	iiimf-server >= 11_4-4

%description -n iiimf-le-unit
Provides Unit language engine for iiimf-server.

%package -n iiimf-le-newpy
Summary:      New Pinyin language engine for iiimf-server
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on
Requires:	iiimf-server >= 11_4-4

%description -n iiimf-le-newpy
Provides New Pinyin language engine for iiimf-server

%package -n iiimf-le-hangul
Summary:      Korean language engine for iiimf-server
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on
Requires:	iiimf-server >= 11_4-4

%description -n iiimf-le-hangul
Provides Korean language engine for iiimf-server

%package -n iiimf-le-canna
Summary:      Japanese Canna engine for iiimf-server
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on
Requires:	iiimf-server >= 11_4-4
Requires: 	Canna >= %{canna_ver}

%description -n iiimf-le-canna
Provides Japanese Canna engine for iiimf-server

%package -n iiimf-x
Summary:      IIIMF XIM BackEnd module
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on
Requires:       XFree86-libs >= 4.3.0

%description -n iiimf-x
IIIMF X Provides XIM bridge modules through which legacy XIM clients should
be able to communicate to IIIMF server.

%package -n iiimf-gtk
Summary:      GTK Input Method Context Module for IIIMP
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on
BuildRequires:	glib2-devel >= 2.2.2
BuildRequires:  pango-devel >= 1.2.3
BuildRequires:	gtk2-devel >= 2.2.2
Requires:       glib2 >= 2.2.2
Requires:	atk >= 1.2.2
Requires:	pango >= 1.2.3
Requires:       gtk2 >= 2.2.2
Requires:	iiimf-client-lib >= 11_4-4

%description -n iiimf-gtk
Gtk Input Method Context for IIIM provides GUI to display input method 
status and to select input languages in your Gtk+ applicaitons.

%package -n iiimf-docs
Summary:      IIIMF documentations
Group:        System/OPENI18N/IIIMF
Autoreqprov:  on

%description -n iiimf-docs
Provides IIIMF documentations

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n %{name}
%patch0 -p1
#%patch1 -p2 -b .DESTDIR
#%patch2 -p1 -b .strlcpy
%patch3 -p1 -b .varargs
#%patch4 -p1 -b .nostatus
%patch5 -p1 -b .64
%patch6 -p1 -b .gimlet
#%patch7 -p1 -b .gimlet-korean
%patch21 -p1 -b .composeIM
%patch22 -p1 -b .conversion
%patch23 -p1 -b .status
%patch25 -p1 -b .canna-bs-del
%patch26 -p1 -b .canna-init-file
%patch28 -p1 -b .canna-unrelated-keys
%patch29 -p1 -b .canna-ignore-ctrl

if [ %{prefix} != "/usr/lib/im" ]; then
  find . -type f | xargs grep -l "/usr/lib/im" | \
	xargs perl -pi -e "s|/usr/lib/im|%{prefix}|g;"
fi

%build
#make prefix=%{prefix} config build

make update-acfiles

make prefix=%{prefix} config

cd lib/CSConv
CFLAGS="$RPM_OPT_FLAGS"			\
./configure --prefix=%{_libdir}/im
make
cd ../..

cd lib/EIMIL
./configure --prefix=%{prefix}
make
cd ../..

cd lib/iiimp
CFLAGS="$RPM_OPT_FLAGS"			\
./configure --prefix=%{prefix}
make
cd ../..

cd lib/iiimcf
CFLAGS="$RPM_OPT_FLAGS"			\
./configure --prefix=%{prefix}
make
cd ../..

cd iiimsf
CFLAGS="$RPM_OPT_FLAGS"		 \
./configure --prefix=%{prefix}
make
cd ..

cd leif
CFLAGS="$RPM_OPT_FLAGS"		\
./configure --prefix=%{prefix}
make
cd ..

cd iiimxcf/xiiimp.so
CFLAGS="$RPM_OPT_FLAGS"			\
#sh ./autogen.sh --prefix=%{prefix}
sh ./configure --prefix=%{prefix}
make
cd ../..

cd iiimxcf/htt_xbe
CFLAGS="$RPM_OPT_FLAGS"			\
./configure --prefix=%{prefix}
make
cd ../..

cd iiimgcf
CFLAGS="$RPM_OPT_FLAGS"			\
./autogen.sh --prefix=%{prefix}	\
	    --sysconfdir=%{_sysconfdir}
make
cd ..

cd gnome-im-switcher
CFLAGS="$RPM_OPT_FLAGS"			\
./autogen.sh --prefix=/usr	\
	    --sysconfdir=%{_sysconfdir} --libdir=/usr/%{_lib}
make
cd ..

%install
#make DESTDIR=${RPM_BUILD_ROOT} prefix=%{prefix} install
#pushd lib/CSConv
#make DESTDIR=${RPM_BUILD_ROOT} prefix=%{prefix} install
#popd

cd lib/CSConv
make DESTDIR=$RPM_BUILD_ROOT install
cd ../..

cd lib/EIMIL
make DESTDIR=$RPM_BUILD_ROOT install
cd ../..

cd lib/iiimp
make DESTDIR=$RPM_BUILD_ROOT install
cd ../..

cd lib/iiimcf
make DESTDIR=$RPM_BUILD_ROOT install
cd ../..

cd iiimsf
make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/
cp sys/RedHat/IIim $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/
cd ..

cd leif
make DESTDIR=$RPM_BUILD_ROOT install
cd ..

cd iiimxcf/xiiimp.so
make DESTDIR=$RPM_BUILD_ROOT install
cd ../..

cd iiimxcf/htt_xbe
make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/iiim/
cd ../..

cd iiimgcf
make DESTDIR=$RPM_BUILD_ROOT install
cd ..

cd gnome-im-switcher
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
make DESTDIR=$RPM_BUILD_ROOT install
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
cd ..

mkdir -p $RPM_BUILD_ROOT/%{_prefix}/bin
pushd $RPM_BUILD_ROOT/%{_prefix}/bin/
ln -s %{_libdir}/im/httx httx
popd

%post -n iiimf-gtk
%{_bindir}/gtk-query-immodules-2.0 > %{_sysconfdir}/gtk-2.0/gtk.immodules

HOME=/root GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source` \
gconftool-2  --makefile-install-rule /etc/gconf/schemas/gnome-im-switcher.schemas > /dev/null

                                                                                
%postun -n iiimf-gtk
%{_bindir}/gtk-query-immodules-2.0 > %{_sysconfdir}/gtk-2.0/gtk.immodules


%preun -n iiimf-server
if [ "$1" = 0 ] ; then
  service IIim stop >/dev/null 2>&1
  /sbin/chkconfig --del IIim
fi

%postun -n iiimf-server
if [ "$1" -ge "1" ]; then
  service IIim condrestart >/dev/null 2>&1
fi


%clean
rm -rf ${RPM_BUILD_ROOT}

#%files
#%defattr(-,root,root)
#%{prefix}/*
#%{_libdir}/gtk-2.0/*
#Disabled for 20030507-1
#/usr/X11R6/lib/X11/locale/common/*

%files -n iiimf-csconv
%defattr (-, root, root)
%{_libdir}/im/csconv/*
%{_libdir}/im/icuconv/*
%{_libdir}/im/share/icu/*

%files -n iiimf-protocol-lib
%defattr (-, root, root)
%{_libdir}/im/lib/libiiimp*so.*
%{_libdir}/im/lib/libEIMIL*so.*

%files -n iiimf-protocol-lib-devel
%defattr (-, root, root)
%{_libdir}/im/lib/libiiimp*.so
%{_libdir}/im/lib/libiiimp*a
%{_libdir}/im/lib/libEIMIL*.so
%{_libdir}/im/lib/libEIMIL*a
%{_libdir}/im/include/iiimp.h
%{_libdir}/im/include/iiimp-character-subsets.h
%{_libdir}/im/include/iiimp-data.h
%{_libdir}/im/include/iiimp-keycode.h
%{_libdir}/im/include/iiimp-opcode.h
%{_libdir}/im/include/EIMIL.h

%files -n iiimf-client-lib
%defattr (-, root, root)
%{_libdir}/im/lib/libiiimcf*.so.*

%files -n iiimf-client-lib-devel
%defattr (-, root, root)
%{_libdir}/im/lib/libiiimcf*.so
%{_libdir}/im/lib/libiiimcf*a
%{_libdir}/im/include/iiimcf.h

%files -n iiimf-server
%defattr (-, root, root)
%{_sysconfdir}/init.d/IIim
%{_libdir}/im/htt.conf
%{_libdir}/im/htt
%{_libdir}/im/htt_server
%{_libdir}/im/bin/*

%files -n iiimf-le-unit
%defattr (-, root, root)
%{_libdir}/im/leif/unitle.so
#%{_libdir}/im/leif/indicle.so
%{_libdir}/im/locale/UNIT/*

%files -n iiimf-le-newpy
%defattr (-, root, root)
%{_libdir}/im/leif/newpy.*
%{_libdir}/im/locale/zh_CN/newpy/*

%files -n iiimf-le-hangul
%defattr (-, root, root)
%{_libdir}/im/leif/hangul.*
%{_libdir}/im/locale/ko_KR/hangul.conf

%files -n iiimf-le-canna
%defattr (-, root, root)
%{_libdir}/im/leif/CannaLE*

%files -n iiimf-x
%defattr (-, root, root)
#%{_sysconfdir}/iiim/xsession
%{_libdir}/im/httx
%{_libdir}/im/htt_xbe
%{_libdir}/im/xiiimp*
%{_prefix}/bin/httx

%files -n iiimf-gtk
%defattr (-, root, root)
%{_libdir}/gtk-2.0/*/immodules/*
%{_sysconfdir}/gconf/schemas/*
%{_libdir}/bonobo/*
%{_libexecdir}/*
%{_datadir}/locale/*
%{_datadir}/gnome-2.0/*
%{_datadir}/gnome-im-switcher/*

%files -n iiimf-docs
%defattr(-, root, root)
%doc doc/*


%changelog
* Wed Apr 28 2004 Yasuma Takeda <yasuma@miraclelinux.com> r11.4-12.15AX
- fixed htt_server loop
- fixed wrong font name

* Tue Apr 20 2004 Shiro Yamada <shiro@miraclelinux.com> r11.4-12.14AX
- Added some canna related patches (patch 25-29)
- Disable patch20
- Update patch22

* Wed Mar 10 2004 Yasuma Takeda <yasuma@miraclelinux.com> r11.4-12.13AX
- Update for Asianux
- add symbolic link /usr/lib/im/httx -> /usr/bin/httx
- add CannaLE patch(No.20)
- add misc patch(No.21-24)

* Mon Feb 16 2004 Yu Shao <yshao@redhat.com> r11.4-12
- #115423, Patch from Jens Petersen

* Mon Feb 16 2004 Yu Shao <yshao@redhat.com> r11.4-11
- #115215, init script doesn't show ok bug
- #113922, gconf error bug

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 10 2004 Yu Shao <yshao@redhat.com> r11.4-9
- #115217, gnonme-im-switcher-applet doesn't start bug

* Fri Feb 6 2004 Yu Shao <yshao@redhat.com> r11.4-8
- more bug fixes, gtk crashing #112290, library inclusion #113925

* Wed Feb 5 2004 Yu Shao <yshao@redhat.com> r11.4-7
- more bug fixes, canna requirement and initscript

* Tue Feb 4 2004 Yu Shao <yshao@redhat.com> r11.4-6
- exclude .svn and change the version using dot
- add obsolete im-sdk and intltool version requirements

* Tue Feb 4 2004 Yu Shao <yshao@redhat.com> r11_4-5
- latest snapshot from openi18n.org

* Fri Jan 9 2004 Yu Shao <yshao@redhat.com> r11_4-4
- fixed packages requirements 

* Fri Dec 19 2003 Yu Shao <yshao@redhat.com> r11_4-3
- latest snapshot build and package splitting according to the 
  discussions on openi18n-im@openi18n.org

* Tue Nov 25 2003 Thomas Woerner <twoerner@redhat.com> 1:11_4-2
- fixed libdir problem

* Tue Nov 18 2003 Thomas Woerner <twoerner@redhat.com>
- Fixed RPATH: Fixed prefix in %%build, simplified %%install,
  Readded BuildRequires for Canna-devel (for CannaLE.so, ..)

* Tue Aug 26 2003 Yu Shao <yshao@redhat.com> r11_4
- im-sdk r11_4 release build
  obsolete Patch4: xiiimp-status_no_status_text.patch

* Tue Jul 29 2003 Bill Nottingham <notting@redhat.com> r11_3.3
- fix build on ia64, enable it

* Thu Jun 19 2003 Yu Shao <yshao@redhat.com> r11_3.2
- added Patch4: xiiimp-status_no_status_text.patch

* Wed Jun 18 2003 Yu Shao <yshao@redhat.com> r11_3.1
- im-sdk r11_3 new release build
  updated im-sdk-20030618-build.patch and
          im-sdk-20030618-varargs.patch

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu May 22 2003 Jeremy Katz <katzj@redhat.com> 20030507-3
- fix to build with gcc 3.3

* Thu May 8 2003 Yu Shao <yshao@redhat.com> 20030507-2
- im-sdk r11_2 missing library fix

* Wed May 7 2003 Yu Shao <yshao@redhat.com> 20030507-1
- im-sdk r11_2 release

* Fri May 2 2003 Yu Shao <yshao@redhat.com> 20030327-3
- patch to fix broken dep #89813

* Mon Apr 28 2003 Tim Powers <timp@redhat.com> 20030327-2
- rebuild to fix broken dep

* Thu Mar 27 2003 Yu Shao <yshao@redhat.com>
- new r11_1 build

* Mon Feb 24 2003 Elliot Lee <sopwith@redhat.com>
- debuginfo rebuild

* Sun Feb 23 2003 Tim Powers <timp@redhat.com>
- added buildprereq on tcp_wrappers

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Wed Jan 22 2003 Yu Shao <yshao@redhat.com>
- added several 64bit patches to build it on all 
  architectures

* Mon Jan 20 2003 Yu Shao <yshao@redhat.com>
- new 20030118 build

* Thu Jan 16 2003 Yu Shao <yshao@redhat.com>
- new codebase with EIMIL/PCE interim implemention
- spec file update
- im-sdk-20030110-buildpatch.patch

* Thu Oct 7 2002 Yu Shao <yshao@redhat.com>
- experimental implementation IIIMSF CVS

* Thu Oct 3 2002 Yu Shao <yshao@redhat.com>
- new stable branch CVS

* Thu Aug 15 2002 Yu Shao <yshao@redhat.com>
- new 20020813 CVS, disable patch2

* Sat Aug 10 2002 Elliot Lee <sopwith@redhat.com>
- rebuilt with gcc-3.2 (we hope)

* Tue Jul 23 2002 Tim Powers <timp@redhat.com> 20011223-7
- build using gcc-3.2-0.1

* Thu Jul 18 2002 Akira TAGOH <tagoh@redhat.com> 20011223-6
- add the owned directory.

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Tue Mar 26 2002 Yukihiro Nakai <ynakai@redhat.com>
- Add some fix for ia64,alpha
- Add strlcpy/strlcat patch, #61898

* Sun Dec 30 2001 Yukihiro Nakai <ynakai@redhat.com>
- Initial release
